<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.util.map;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.Serializable;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.lang.reflect.Method;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.util.ArrayList;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.util.Collection;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.util.Iterator;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.util.Map;<a name="line.41"></a>
<FONT color="green">042</FONT>    import java.util.NoSuchElementException;<a name="line.42"></a>
<FONT color="green">043</FONT>    <a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.util.ints.AbstractIntIterator;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.util.ints.DefaultIntList;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.util.ints.IntCollection;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.util.ints.IntCollections;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.util.ints.IntHashMap;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.util.ints.IntIterable;<a name="line.49"></a>
<FONT color="green">050</FONT>    import ch.javasoft.util.ints.IntIterator;<a name="line.50"></a>
<FONT color="green">051</FONT>    import ch.javasoft.util.ints.IntList;<a name="line.51"></a>
<FONT color="green">052</FONT>    import ch.javasoft.util.ints.IntMap;<a name="line.52"></a>
<FONT color="green">053</FONT>    import ch.javasoft.util.ints.IntSet;<a name="line.53"></a>
<FONT color="green">054</FONT>    <a name="line.54"></a>
<FONT color="green">055</FONT>    /**<a name="line.55"></a>
<FONT color="green">056</FONT>     * The &lt;code&gt;IntIntMultiValueMap&lt;/code&gt; is a mutable multi value map for int<a name="line.56"></a>
<FONT color="green">057</FONT>     * keys and values. <a name="line.57"></a>
<FONT color="green">058</FONT>     */<a name="line.58"></a>
<FONT color="green">059</FONT>    public class DefaultIntIntMultiValueMap extends AbstractMutableMultiValueMap&lt;Integer, Integer&gt; <a name="line.59"></a>
<FONT color="green">060</FONT>            implements IntIntMultiValueMap, Cloneable, Serializable {<a name="line.60"></a>
<FONT color="green">061</FONT>                    <a name="line.61"></a>
<FONT color="green">062</FONT>            private static final long serialVersionUID = -93905570980186647L;<a name="line.62"></a>
<FONT color="green">063</FONT>            <a name="line.63"></a>
<FONT color="green">064</FONT>            private final IntMap&lt;IntCollection&gt; map;<a name="line.64"></a>
<FONT color="green">065</FONT>            <a name="line.65"></a>
<FONT color="green">066</FONT>            /**<a name="line.66"></a>
<FONT color="green">067</FONT>             * Constructor for an empty multi value map<a name="line.67"></a>
<FONT color="green">068</FONT>             */<a name="line.68"></a>
<FONT color="green">069</FONT>            public DefaultIntIntMultiValueMap() {<a name="line.69"></a>
<FONT color="green">070</FONT>                    map = createMap();<a name="line.70"></a>
<FONT color="green">071</FONT>            }<a name="line.71"></a>
<FONT color="green">072</FONT>            /**<a name="line.72"></a>
<FONT color="green">073</FONT>             * Constructor for a multi value map based on an existing one<a name="line.73"></a>
<FONT color="green">074</FONT>             */<a name="line.74"></a>
<FONT color="green">075</FONT>            public DefaultIntIntMultiValueMap(MultiValueMap&lt;? extends Integer, ? extends Integer&gt; copy) {<a name="line.75"></a>
<FONT color="green">076</FONT>                    map = createMap();<a name="line.76"></a>
<FONT color="green">077</FONT>                    for (final Integer key : copy.keySet()) {<a name="line.77"></a>
<FONT color="green">078</FONT>                            final IntCollection coll = createCollection(key.intValue());<a name="line.78"></a>
<FONT color="green">079</FONT>                            coll.addAll(copy.get(key));<a name="line.79"></a>
<FONT color="green">080</FONT>                            map.put(key, coll);<a name="line.80"></a>
<FONT color="green">081</FONT>                    }<a name="line.81"></a>
<FONT color="green">082</FONT>            }<a name="line.82"></a>
<FONT color="green">083</FONT>            /**<a name="line.83"></a>
<FONT color="green">084</FONT>             * Constructor for a multi value map based on an existing one<a name="line.84"></a>
<FONT color="green">085</FONT>             */<a name="line.85"></a>
<FONT color="green">086</FONT>            public DefaultIntIntMultiValueMap(DefaultIntIntMultiValueMap copy) {<a name="line.86"></a>
<FONT color="green">087</FONT>                    map = createMap();<a name="line.87"></a>
<FONT color="green">088</FONT>                    final IntIterator keyIt = keySet().iterator();<a name="line.88"></a>
<FONT color="green">089</FONT>                    while (keyIt.hasNext()) {<a name="line.89"></a>
<FONT color="green">090</FONT>                            final int key = keyIt.nextInt();<a name="line.90"></a>
<FONT color="green">091</FONT>                            final IntCollection coll = createCollection(key);<a name="line.91"></a>
<FONT color="green">092</FONT>                            coll.addAll(copy.get(key));<a name="line.92"></a>
<FONT color="green">093</FONT>                            map.put(key, coll);<a name="line.93"></a>
<FONT color="green">094</FONT>                    }<a name="line.94"></a>
<FONT color="green">095</FONT>            }<a name="line.95"></a>
<FONT color="green">096</FONT>            <a name="line.96"></a>
<FONT color="green">097</FONT>            /**<a name="line.97"></a>
<FONT color="green">098</FONT>             * Constructor for a multi value map based on the given collection map. The<a name="line.98"></a>
<FONT color="green">099</FONT>             * submitted map and its contents are not copied, thus, changes to it will<a name="line.99"></a>
<FONT color="green">100</FONT>             * also affect the newly created multi value map instance. To copy the<a name="line.100"></a>
<FONT color="green">101</FONT>             * submitted map, {@link #createFromCollectionMap(Map)} can be used.<a name="line.101"></a>
<FONT color="green">102</FONT>             * <a name="line.102"></a>
<FONT color="green">103</FONT>             * @param       collectionMap the map to use for this multi value map<a name="line.103"></a>
<FONT color="green">104</FONT>             */<a name="line.104"></a>
<FONT color="green">105</FONT>            public DefaultIntIntMultiValueMap(IntMap&lt;IntCollection&gt; collectionMap) {<a name="line.105"></a>
<FONT color="green">106</FONT>                    map = collectionMap;<a name="line.106"></a>
<FONT color="green">107</FONT>            }<a name="line.107"></a>
<FONT color="green">108</FONT>    <a name="line.108"></a>
<FONT color="green">109</FONT>            /**<a name="line.109"></a>
<FONT color="green">110</FONT>             * Creates a multi value map from an existing (single value) map<a name="line.110"></a>
<FONT color="green">111</FONT>             * <a name="line.111"></a>
<FONT color="green">112</FONT>             * @param singleMap     the map containing key/value pairs to add to the new map        <a name="line.112"></a>
<FONT color="green">113</FONT>             * @return      a new multi value map containing the entries of the submitted<a name="line.113"></a>
<FONT color="green">114</FONT>             *                      single value map<a name="line.114"></a>
<FONT color="green">115</FONT>             */<a name="line.115"></a>
<FONT color="green">116</FONT>            public static DefaultIntIntMultiValueMap createFromSingleValueMap(Map&lt;? extends Integer, ? extends Integer&gt; singleMap) {<a name="line.116"></a>
<FONT color="green">117</FONT>                    final DefaultIntIntMultiValueMap map = new DefaultIntIntMultiValueMap();<a name="line.117"></a>
<FONT color="green">118</FONT>                    for (final Integer key : singleMap.keySet()) {<a name="line.118"></a>
<FONT color="green">119</FONT>                            map.add(key, singleMap.get(key));<a name="line.119"></a>
<FONT color="green">120</FONT>                    }<a name="line.120"></a>
<FONT color="green">121</FONT>                    return map;<a name="line.121"></a>
<FONT color="green">122</FONT>            }<a name="line.122"></a>
<FONT color="green">123</FONT>            /**<a name="line.123"></a>
<FONT color="green">124</FONT>             * Creates a multi value map from an existing collection map. <a name="line.124"></a>
<FONT color="green">125</FONT>             * <a name="line.125"></a>
<FONT color="green">126</FONT>             * @param collectionMap the map containing key/list-of-value entries to add <a name="line.126"></a>
<FONT color="green">127</FONT>             *                                              to the new map  <a name="line.127"></a>
<FONT color="green">128</FONT>             * @return      a new multi value map containing the entries of the submitted<a name="line.128"></a>
<FONT color="green">129</FONT>             *                      collection map<a name="line.129"></a>
<FONT color="green">130</FONT>             */<a name="line.130"></a>
<FONT color="green">131</FONT>            public static DefaultIntIntMultiValueMap createFromCollectionMap(Map&lt;? extends Integer, ? extends Collection&lt;? extends Integer&gt;&gt; collectionMap) {<a name="line.131"></a>
<FONT color="green">132</FONT>                    final DefaultIntIntMultiValueMap map = new DefaultIntIntMultiValueMap();<a name="line.132"></a>
<FONT color="green">133</FONT>                    map.addAllNested(collectionMap);<a name="line.133"></a>
<FONT color="green">134</FONT>                    return map;<a name="line.134"></a>
<FONT color="green">135</FONT>            }<a name="line.135"></a>
<FONT color="green">136</FONT>            <a name="line.136"></a>
<FONT color="green">137</FONT>            /**<a name="line.137"></a>
<FONT color="green">138</FONT>             * Adds the given value to the multi value map<a name="line.138"></a>
<FONT color="green">139</FONT>             * <a name="line.139"></a>
<FONT color="green">140</FONT>             * @param key   the key which identifies the value collection<a name="line.140"></a>
<FONT color="green">141</FONT>             * @param value the value to add<a name="line.141"></a>
<FONT color="green">142</FONT>             * <a name="line.142"></a>
<FONT color="green">143</FONT>             * @return      true if this map has changed, which is usually the case. If sets<a name="line.143"></a>
<FONT color="green">144</FONT>             *                      are used as key collections, however, the method could also <a name="line.144"></a>
<FONT color="green">145</FONT>             *                      return false if the given value already existed.<a name="line.145"></a>
<FONT color="green">146</FONT>             * @throws UnsupportedOperationException if this is an immutable map<a name="line.146"></a>
<FONT color="green">147</FONT>             */<a name="line.147"></a>
<FONT color="green">148</FONT>            @Override<a name="line.148"></a>
<FONT color="green">149</FONT>            public boolean add(Integer key, Integer value) {<a name="line.149"></a>
<FONT color="green">150</FONT>                    return add(key.intValue(), value.intValue());<a name="line.150"></a>
<FONT color="green">151</FONT>            }<a name="line.151"></a>
<FONT color="green">152</FONT>            public boolean add(int key, int value) {<a name="line.152"></a>
<FONT color="green">153</FONT>                    final IntCollection coll = getOrCreateCollection(key);<a name="line.153"></a>
<FONT color="green">154</FONT>                    return coll.addInt(value);<a name="line.154"></a>
<FONT color="green">155</FONT>            }<a name="line.155"></a>
<FONT color="green">156</FONT>            public boolean addAll(int key, IntCollection values) {<a name="line.156"></a>
<FONT color="green">157</FONT>                    if (values.isEmpty()) return false;<a name="line.157"></a>
<FONT color="green">158</FONT>                    final IntCollection coll = getOrCreateCollection(key);<a name="line.158"></a>
<FONT color="green">159</FONT>                    return coll.addAll(values);             <a name="line.159"></a>
<FONT color="green">160</FONT>            }<a name="line.160"></a>
<FONT color="green">161</FONT>            @Override<a name="line.161"></a>
<FONT color="green">162</FONT>            public boolean addAll(Integer key, Collection&lt;? extends Integer&gt; values) {<a name="line.162"></a>
<FONT color="green">163</FONT>                    if (values.isEmpty()) return false;<a name="line.163"></a>
<FONT color="green">164</FONT>                    final IntCollection coll = getOrCreateCollection(key.intValue());<a name="line.164"></a>
<FONT color="green">165</FONT>                    return coll.addAll(values);             <a name="line.165"></a>
<FONT color="green">166</FONT>            }<a name="line.166"></a>
<FONT color="green">167</FONT>    <a name="line.167"></a>
<FONT color="green">168</FONT>            public boolean addAll(int key, int... values) {<a name="line.168"></a>
<FONT color="green">169</FONT>                    boolean any = false;<a name="line.169"></a>
<FONT color="green">170</FONT>                    for (final int value : values) {<a name="line.170"></a>
<FONT color="green">171</FONT>                            any |= add(key, value);<a name="line.171"></a>
<FONT color="green">172</FONT>                    }<a name="line.172"></a>
<FONT color="green">173</FONT>                    return any;<a name="line.173"></a>
<FONT color="green">174</FONT>            }<a name="line.174"></a>
<FONT color="green">175</FONT>            public boolean addAll(IntMap&lt;? extends Integer&gt; map) {<a name="line.175"></a>
<FONT color="green">176</FONT>                    boolean any = false;<a name="line.176"></a>
<FONT color="green">177</FONT>                    final IntIterator keyIt = map.keySet().iterator();<a name="line.177"></a>
<FONT color="green">178</FONT>                    while (keyIt.hasNext()) {<a name="line.178"></a>
<FONT color="green">179</FONT>                            final int key = keyIt.nextInt();<a name="line.179"></a>
<FONT color="green">180</FONT>                            any |= add(key, map.get(key).intValue());<a name="line.180"></a>
<FONT color="green">181</FONT>                    }<a name="line.181"></a>
<FONT color="green">182</FONT>                    return any;<a name="line.182"></a>
<FONT color="green">183</FONT>            }<a name="line.183"></a>
<FONT color="green">184</FONT>            public boolean addAll(IntIntMultiValueMap mapping) {<a name="line.184"></a>
<FONT color="green">185</FONT>                    boolean any = false;<a name="line.185"></a>
<FONT color="green">186</FONT>                    final IntIterator keyIt = mapping.keySet().iterator();<a name="line.186"></a>
<FONT color="green">187</FONT>                    while (keyIt.hasNext()) {<a name="line.187"></a>
<FONT color="green">188</FONT>                            final int key = keyIt.nextInt();<a name="line.188"></a>
<FONT color="green">189</FONT>                            any |= addAll(key, mapping.get(key));<a name="line.189"></a>
<FONT color="green">190</FONT>                    }<a name="line.190"></a>
<FONT color="green">191</FONT>                    return any;<a name="line.191"></a>
<FONT color="green">192</FONT>            }<a name="line.192"></a>
<FONT color="green">193</FONT>            public boolean addAllNested(IntMap&lt;? extends IntCollection&gt; map) {<a name="line.193"></a>
<FONT color="green">194</FONT>                    boolean any = false;<a name="line.194"></a>
<FONT color="green">195</FONT>                    final IntIterator keyIt = map.keySet().iterator();<a name="line.195"></a>
<FONT color="green">196</FONT>                    while (keyIt.hasNext()) {<a name="line.196"></a>
<FONT color="green">197</FONT>                            final int key = keyIt.nextInt();<a name="line.197"></a>
<FONT color="green">198</FONT>                            any |= addAll(key, map.get(key));<a name="line.198"></a>
<FONT color="green">199</FONT>                    }<a name="line.199"></a>
<FONT color="green">200</FONT>                    return any;<a name="line.200"></a>
<FONT color="green">201</FONT>            }<a name="line.201"></a>
<FONT color="green">202</FONT>    <a name="line.202"></a>
<FONT color="green">203</FONT>            /**<a name="line.203"></a>
<FONT color="green">204</FONT>             * Returns an unmodifiable value collection.<a name="line.204"></a>
<FONT color="green">205</FONT>             * <a name="line.205"></a>
<FONT color="green">206</FONT>             * @see MultiValueMap#get(Object)<a name="line.206"></a>
<FONT color="green">207</FONT>             */<a name="line.207"></a>
<FONT color="green">208</FONT>            public IntCollection get(Object key) {<a name="line.208"></a>
<FONT color="green">209</FONT>                    final IntCollection coll = map.get(key);<a name="line.209"></a>
<FONT color="green">210</FONT>                    if (coll == null) return IntCollections.EMPTY_LIST;<a name="line.210"></a>
<FONT color="green">211</FONT>                    return IntCollections.unmodifiableCollection(coll);<a name="line.211"></a>
<FONT color="green">212</FONT>            }<a name="line.212"></a>
<FONT color="green">213</FONT>            /**<a name="line.213"></a>
<FONT color="green">214</FONT>             * Returns an unmodifiable value collection.<a name="line.214"></a>
<FONT color="green">215</FONT>             * <a name="line.215"></a>
<FONT color="green">216</FONT>             * @see MultiValueMap#get(Object)<a name="line.216"></a>
<FONT color="green">217</FONT>             */<a name="line.217"></a>
<FONT color="green">218</FONT>            public IntCollection get(int key) {<a name="line.218"></a>
<FONT color="green">219</FONT>                    final IntCollection coll = map.get(key);<a name="line.219"></a>
<FONT color="green">220</FONT>                    if (coll == null) return IntCollections.EMPTY_LIST;<a name="line.220"></a>
<FONT color="green">221</FONT>                    return IntCollections.unmodifiableCollection(coll);<a name="line.221"></a>
<FONT color="green">222</FONT>            }<a name="line.222"></a>
<FONT color="green">223</FONT>            <a name="line.223"></a>
<FONT color="green">224</FONT>            @Override<a name="line.224"></a>
<FONT color="green">225</FONT>            public Integer getFirst(Object key) {<a name="line.225"></a>
<FONT color="green">226</FONT>                    final IntCollection coll = map.get(key);<a name="line.226"></a>
<FONT color="green">227</FONT>                    return coll == null ? null : coll.iterator().next();<a name="line.227"></a>
<FONT color="green">228</FONT>            }<a name="line.228"></a>
<FONT color="green">229</FONT>            /**<a name="line.229"></a>
<FONT color="green">230</FONT>             * Returns the first value associated with this key, or throws an exception<a name="line.230"></a>
<FONT color="green">231</FONT>             * if no such value exists<a name="line.231"></a>
<FONT color="green">232</FONT>             * <a name="line.232"></a>
<FONT color="green">233</FONT>             * @param key   the key to search for<a name="line.233"></a>
<FONT color="green">234</FONT>             * @return the first value associated with this key<a name="line.234"></a>
<FONT color="green">235</FONT>             * @throws NoSuchElementException if no value exists for the given key<a name="line.235"></a>
<FONT color="green">236</FONT>             */<a name="line.236"></a>
<FONT color="green">237</FONT>            public int getFirst(int key) {<a name="line.237"></a>
<FONT color="green">238</FONT>                    final IntCollection coll = map.get(key);<a name="line.238"></a>
<FONT color="green">239</FONT>                    if (coll == null) throw new NoSuchElementException();<a name="line.239"></a>
<FONT color="green">240</FONT>                    return coll instanceof IntList ? ((IntList)coll).getInt(0) : coll.iterator().nextInt();<a name="line.240"></a>
<FONT color="green">241</FONT>            }<a name="line.241"></a>
<FONT color="green">242</FONT>            public int count(Object key) {<a name="line.242"></a>
<FONT color="green">243</FONT>                    final IntCollection coll = map.get(key);<a name="line.243"></a>
<FONT color="green">244</FONT>                    return coll == null ? 0 : coll.size();<a name="line.244"></a>
<FONT color="green">245</FONT>            }<a name="line.245"></a>
<FONT color="green">246</FONT>            public int count(int key) {<a name="line.246"></a>
<FONT color="green">247</FONT>                    final IntCollection coll = map.get(key);<a name="line.247"></a>
<FONT color="green">248</FONT>                    return coll == null ? 0 : coll.size();<a name="line.248"></a>
<FONT color="green">249</FONT>            }<a name="line.249"></a>
<FONT color="green">250</FONT>            @Override<a name="line.250"></a>
<FONT color="green">251</FONT>            public boolean isEmpty() {<a name="line.251"></a>
<FONT color="green">252</FONT>                    return map.isEmpty();<a name="line.252"></a>
<FONT color="green">253</FONT>            }<a name="line.253"></a>
<FONT color="green">254</FONT>            @Override<a name="line.254"></a>
<FONT color="green">255</FONT>            public boolean contains(Object key) {<a name="line.255"></a>
<FONT color="green">256</FONT>                    return map.containsKey(key);<a name="line.256"></a>
<FONT color="green">257</FONT>            }<a name="line.257"></a>
<FONT color="green">258</FONT>            public boolean contains(int key) {<a name="line.258"></a>
<FONT color="green">259</FONT>                    return map.containsKey(key);<a name="line.259"></a>
<FONT color="green">260</FONT>            }<a name="line.260"></a>
<FONT color="green">261</FONT>            public boolean contains(Object key, Integer value) {<a name="line.261"></a>
<FONT color="green">262</FONT>                    final IntCollection coll = map.get(key);<a name="line.262"></a>
<FONT color="green">263</FONT>                    return coll == null ? false : coll.contains(value);<a name="line.263"></a>
<FONT color="green">264</FONT>            }<a name="line.264"></a>
<FONT color="green">265</FONT>            public boolean contains(int key, int value) {<a name="line.265"></a>
<FONT color="green">266</FONT>                    final IntCollection coll = map.get(key);<a name="line.266"></a>
<FONT color="green">267</FONT>                    return coll == null ? false : coll.containsInt(value);<a name="line.267"></a>
<FONT color="green">268</FONT>            }<a name="line.268"></a>
<FONT color="green">269</FONT>            /**<a name="line.269"></a>
<FONT color="green">270</FONT>             * Returns all values belonging to this key, i.e. the value collection is<a name="line.270"></a>
<FONT color="green">271</FONT>             * cleared<a name="line.271"></a>
<FONT color="green">272</FONT>             * <a name="line.272"></a>
<FONT color="green">273</FONT>             * @param key   the key which identifies the value collection<a name="line.273"></a>
<FONT color="green">274</FONT>             * <a name="line.274"></a>
<FONT color="green">275</FONT>             * @return      true if this map has changed as a consequence of this <a name="line.275"></a>
<FONT color="green">276</FONT>             *                      operation<a name="line.276"></a>
<FONT color="green">277</FONT>             * @throws UnsupportedOperationException if this is an immutable map<a name="line.277"></a>
<FONT color="green">278</FONT>             */<a name="line.278"></a>
<FONT color="green">279</FONT>            @Override<a name="line.279"></a>
<FONT color="green">280</FONT>            public boolean remove(Object key) {<a name="line.280"></a>
<FONT color="green">281</FONT>                    return map.remove(key) != null;<a name="line.281"></a>
<FONT color="green">282</FONT>            }<a name="line.282"></a>
<FONT color="green">283</FONT>            public boolean remove(int key) {<a name="line.283"></a>
<FONT color="green">284</FONT>                    return map.remove(key) != null;<a name="line.284"></a>
<FONT color="green">285</FONT>            }<a name="line.285"></a>
<FONT color="green">286</FONT>            /**<a name="line.286"></a>
<FONT color="green">287</FONT>             * Returns a single value of the value collection, if it exists<a name="line.287"></a>
<FONT color="green">288</FONT>             * <a name="line.288"></a>
<FONT color="green">289</FONT>             * @param key   the key which identifies the value collection<a name="line.289"></a>
<FONT color="green">290</FONT>             * @param value the value to remove<a name="line.290"></a>
<FONT color="green">291</FONT>             * <a name="line.291"></a>
<FONT color="green">292</FONT>             * @return      true if this map has changed as a consequence of this <a name="line.292"></a>
<FONT color="green">293</FONT>             *                      operation<a name="line.293"></a>
<FONT color="green">294</FONT>             * @throws UnsupportedOperationException if this is an immutable map<a name="line.294"></a>
<FONT color="green">295</FONT>             */<a name="line.295"></a>
<FONT color="green">296</FONT>            @Override<a name="line.296"></a>
<FONT color="green">297</FONT>            public boolean remove(Object key, Integer value) {<a name="line.297"></a>
<FONT color="green">298</FONT>                    final IntCollection coll = map.get(key);<a name="line.298"></a>
<FONT color="green">299</FONT>                    if (coll == null) return false;<a name="line.299"></a>
<FONT color="green">300</FONT>                    if (coll.remove(value)) {<a name="line.300"></a>
<FONT color="green">301</FONT>                            if (coll.isEmpty()) {<a name="line.301"></a>
<FONT color="green">302</FONT>                                    map.remove(key);<a name="line.302"></a>
<FONT color="green">303</FONT>                            }<a name="line.303"></a>
<FONT color="green">304</FONT>                            return true;<a name="line.304"></a>
<FONT color="green">305</FONT>                    }<a name="line.305"></a>
<FONT color="green">306</FONT>                    return false;<a name="line.306"></a>
<FONT color="green">307</FONT>            }<a name="line.307"></a>
<FONT color="green">308</FONT>            public boolean remove(int key, int value) {<a name="line.308"></a>
<FONT color="green">309</FONT>                    final IntCollection coll = map.get(key);<a name="line.309"></a>
<FONT color="green">310</FONT>                    if (coll == null) return false;<a name="line.310"></a>
<FONT color="green">311</FONT>                    if (coll.removeInt(value)) {<a name="line.311"></a>
<FONT color="green">312</FONT>                            if (coll.isEmpty()) {<a name="line.312"></a>
<FONT color="green">313</FONT>                                    map.remove(key);<a name="line.313"></a>
<FONT color="green">314</FONT>                            }<a name="line.314"></a>
<FONT color="green">315</FONT>                            return true;<a name="line.315"></a>
<FONT color="green">316</FONT>                    }<a name="line.316"></a>
<FONT color="green">317</FONT>                    return false;<a name="line.317"></a>
<FONT color="green">318</FONT>            }<a name="line.318"></a>
<FONT color="green">319</FONT>            <a name="line.319"></a>
<FONT color="green">320</FONT>            /**<a name="line.320"></a>
<FONT color="green">321</FONT>             * Removes all entries from this mapping<a name="line.321"></a>
<FONT color="green">322</FONT>             * <a name="line.322"></a>
<FONT color="green">323</FONT>             * @return      true if this mapping has changed as a consequence of this <a name="line.323"></a>
<FONT color="green">324</FONT>             *                      operation<a name="line.324"></a>
<FONT color="green">325</FONT>             * @throws UnsupportedOperationException if this is an immutable map<a name="line.325"></a>
<FONT color="green">326</FONT>             */<a name="line.326"></a>
<FONT color="green">327</FONT>            @Override<a name="line.327"></a>
<FONT color="green">328</FONT>            public boolean clear() {<a name="line.328"></a>
<FONT color="green">329</FONT>                    if (!map.isEmpty()) {<a name="line.329"></a>
<FONT color="green">330</FONT>                            map.clear();<a name="line.330"></a>
<FONT color="green">331</FONT>                            return true;<a name="line.331"></a>
<FONT color="green">332</FONT>                    }<a name="line.332"></a>
<FONT color="green">333</FONT>                    return false;<a name="line.333"></a>
<FONT color="green">334</FONT>            }<a name="line.334"></a>
<FONT color="green">335</FONT>            <a name="line.335"></a>
<FONT color="green">336</FONT>            /**<a name="line.336"></a>
<FONT color="green">337</FONT>             * Returns an modifiable key set, i.e. removal of keys is also reflected in <a name="line.337"></a>
<FONT color="green">338</FONT>             * this multi value map<a name="line.338"></a>
<FONT color="green">339</FONT>             * <a name="line.339"></a>
<FONT color="green">340</FONT>             * @see MultiValueMap#get(Object)<a name="line.340"></a>
<FONT color="green">341</FONT>             */<a name="line.341"></a>
<FONT color="green">342</FONT>            public IntSet keySet() {<a name="line.342"></a>
<FONT color="green">343</FONT>                    return map.keySet();<a name="line.343"></a>
<FONT color="green">344</FONT>            }<a name="line.344"></a>
<FONT color="green">345</FONT>            <a name="line.345"></a>
<FONT color="green">346</FONT>            /**<a name="line.346"></a>
<FONT color="green">347</FONT>             * Returns an unmodifiable iterator for all values<a name="line.347"></a>
<FONT color="green">348</FONT>             * <a name="line.348"></a>
<FONT color="green">349</FONT>             * @see MultiValueMap#values()<a name="line.349"></a>
<FONT color="green">350</FONT>             */<a name="line.350"></a>
<FONT color="green">351</FONT>            @Override<a name="line.351"></a>
<FONT color="green">352</FONT>            public IntIterable values() {   <a name="line.352"></a>
<FONT color="green">353</FONT>                    return new IntIterable() {<a name="line.353"></a>
<FONT color="green">354</FONT>                            public IntIterator iterator() {<a name="line.354"></a>
<FONT color="green">355</FONT>                                    return new AbstractIntIterator() {<a name="line.355"></a>
<FONT color="green">356</FONT>                                            private final Iterator&lt;? extends IntIterable&gt; mItIt = map.values().iterator();<a name="line.356"></a>
<FONT color="green">357</FONT>                                            private IntIterator     mIt     = nextIterator();<a name="line.357"></a>
<FONT color="green">358</FONT>                                            private IntIterator nextIterator() {<a name="line.358"></a>
<FONT color="green">359</FONT>                                                    IntIterable itbl = mItIt.hasNext() ? mItIt.next() : null;<a name="line.359"></a>
<FONT color="green">360</FONT>                                                    if (itbl != null) {<a name="line.360"></a>
<FONT color="green">361</FONT>                                                            IntIterator it = itbl.iterator();<a name="line.361"></a>
<FONT color="green">362</FONT>                                                            return it.hasNext() ? it : nextIterator();<a name="line.362"></a>
<FONT color="green">363</FONT>                                                    }<a name="line.363"></a>
<FONT color="green">364</FONT>                                                    return null;<a name="line.364"></a>
<FONT color="green">365</FONT>                                            }<a name="line.365"></a>
<FONT color="green">366</FONT>                                            public boolean hasNext() {<a name="line.366"></a>
<FONT color="green">367</FONT>                                                    if (mIt == null) return false;<a name="line.367"></a>
<FONT color="green">368</FONT>                                                    if (mIt.hasNext()) return true;<a name="line.368"></a>
<FONT color="green">369</FONT>                                                    mIt = nextIterator();<a name="line.369"></a>
<FONT color="green">370</FONT>                                                    return hasNext();<a name="line.370"></a>
<FONT color="green">371</FONT>                                            }<a name="line.371"></a>
<FONT color="green">372</FONT>                                            public int nextInt() {<a name="line.372"></a>
<FONT color="green">373</FONT>                                                    if (hasNext()) {<a name="line.373"></a>
<FONT color="green">374</FONT>                                                            return mIt.nextInt();<a name="line.374"></a>
<FONT color="green">375</FONT>                                                    }<a name="line.375"></a>
<FONT color="green">376</FONT>                                                    throw new NoSuchElementException();<a name="line.376"></a>
<FONT color="green">377</FONT>                                            }<a name="line.377"></a>
<FONT color="green">378</FONT>                                            @Override<a name="line.378"></a>
<FONT color="green">379</FONT>                                            public void remove() {<a name="line.379"></a>
<FONT color="green">380</FONT>                                                    if (mIt == null) throw new NoSuchElementException();<a name="line.380"></a>
<FONT color="green">381</FONT>                                                    mIt.remove();<a name="line.381"></a>
<FONT color="green">382</FONT>                                            }<a name="line.382"></a>
<FONT color="green">383</FONT>                                    };<a name="line.383"></a>
<FONT color="green">384</FONT>                            }<a name="line.384"></a>
<FONT color="green">385</FONT>                    };<a name="line.385"></a>
<FONT color="green">386</FONT>            }<a name="line.386"></a>
<FONT color="green">387</FONT>            <a name="line.387"></a>
<FONT color="green">388</FONT>            /**<a name="line.388"></a>
<FONT color="green">389</FONT>             * Implementation returns an {@link IntHashMap} containing <a name="line.389"></a>
<FONT color="green">390</FONT>             * {@link DefaultIntList} instances. <a name="line.390"></a>
<FONT color="green">391</FONT>             * &lt;p&gt;<a name="line.391"></a>
<FONT color="green">392</FONT>             * Changing the returned map does not affect this multi value map.<a name="line.392"></a>
<FONT color="green">393</FONT>             * <a name="line.393"></a>
<FONT color="green">394</FONT>             * @see ch.javasoft.util.map.MultiValueMap#asCollectionMap()<a name="line.394"></a>
<FONT color="green">395</FONT>             */<a name="line.395"></a>
<FONT color="green">396</FONT>            @Override<a name="line.396"></a>
<FONT color="green">397</FONT>            public IntMap&lt;? extends IntCollection&gt; asCollectionMap() {<a name="line.397"></a>
<FONT color="green">398</FONT>                    final IntHashMap&lt;IntCollection&gt; map = new IntHashMap&lt;IntCollection&gt;();<a name="line.398"></a>
<FONT color="green">399</FONT>                    final IntIterator keyIt = keySet().iterator();<a name="line.399"></a>
<FONT color="green">400</FONT>                    while (keyIt.hasNext()) {<a name="line.400"></a>
<FONT color="green">401</FONT>                            final int key = keyIt.nextInt();<a name="line.401"></a>
<FONT color="green">402</FONT>                            map.put(key, new DefaultIntList(get(key)));<a name="line.402"></a>
<FONT color="green">403</FONT>                    }<a name="line.403"></a>
<FONT color="green">404</FONT>                    return map;<a name="line.404"></a>
<FONT color="green">405</FONT>            }<a name="line.405"></a>
<FONT color="green">406</FONT>            /**<a name="line.406"></a>
<FONT color="green">407</FONT>             * Implementation returns an {@link IntHashMap} containing <a name="line.407"></a>
<FONT color="green">408</FONT>             * the single values.<a name="line.408"></a>
<FONT color="green">409</FONT>             * &lt;p&gt;<a name="line.409"></a>
<FONT color="green">410</FONT>             * Changing the returned map does not affect this multi value map.<a name="line.410"></a>
<FONT color="green">411</FONT>             * <a name="line.411"></a>
<FONT color="green">412</FONT>             * @see ch.javasoft.util.map.MultiValueMap#asSingleValueMap()<a name="line.412"></a>
<FONT color="green">413</FONT>             */<a name="line.413"></a>
<FONT color="green">414</FONT>            @Override<a name="line.414"></a>
<FONT color="green">415</FONT>            public IntMap&lt;Integer&gt; asSingleValueMap() {<a name="line.415"></a>
<FONT color="green">416</FONT>                    final IntHashMap&lt;Integer&gt; map = new IntHashMap&lt;Integer&gt;();<a name="line.416"></a>
<FONT color="green">417</FONT>                    final IntIterator keyIt = keySet().iterator();<a name="line.417"></a>
<FONT color="green">418</FONT>                    while (keyIt.hasNext()) {<a name="line.418"></a>
<FONT color="green">419</FONT>                            final int key = keyIt.nextInt();<a name="line.419"></a>
<FONT color="green">420</FONT>                            map.put(key, get(key).iterator().next());<a name="line.420"></a>
<FONT color="green">421</FONT>                    }<a name="line.421"></a>
<FONT color="green">422</FONT>                    return map;<a name="line.422"></a>
<FONT color="green">423</FONT>            }<a name="line.423"></a>
<FONT color="green">424</FONT>            /**<a name="line.424"></a>
<FONT color="green">425</FONT>             * Implementation returns a new {@link DefaultIntIntMultiValueMap} instance.<a name="line.425"></a>
<FONT color="green">426</FONT>             * &lt;p&gt;<a name="line.426"></a>
<FONT color="green">427</FONT>             * Changing the returned map does not affect this multi value map.<a name="line.427"></a>
<FONT color="green">428</FONT>             * <a name="line.428"></a>
<FONT color="green">429</FONT>             * @see ch.javasoft.util.map.MultiValueMap#invert()<a name="line.429"></a>
<FONT color="green">430</FONT>             */<a name="line.430"></a>
<FONT color="green">431</FONT>            @Override<a name="line.431"></a>
<FONT color="green">432</FONT>            public IntIntMultiValueMap invert() {<a name="line.432"></a>
<FONT color="green">433</FONT>                    final IntIntMultiValueMap inv = new DefaultIntIntMultiValueMap();<a name="line.433"></a>
<FONT color="green">434</FONT>                    final IntIterator keyIt = keySet().iterator();<a name="line.434"></a>
<FONT color="green">435</FONT>                    while (keyIt.hasNext()) {<a name="line.435"></a>
<FONT color="green">436</FONT>                            final int key = keyIt.nextInt();<a name="line.436"></a>
<FONT color="green">437</FONT>                            final IntIterator valIt = get(key).iterator();<a name="line.437"></a>
<FONT color="green">438</FONT>                            while (valIt.hasNext()) {<a name="line.438"></a>
<FONT color="green">439</FONT>                                    final int val = valIt.nextInt();<a name="line.439"></a>
<FONT color="green">440</FONT>                                    inv.add(val, key);<a name="line.440"></a>
<FONT color="green">441</FONT>                            }<a name="line.441"></a>
<FONT color="green">442</FONT>                    }<a name="line.442"></a>
<FONT color="green">443</FONT>                    return inv;<a name="line.443"></a>
<FONT color="green">444</FONT>            }<a name="line.444"></a>
<FONT color="green">445</FONT>            <a name="line.445"></a>
<FONT color="green">446</FONT>            /* (non-Javadoc)<a name="line.446"></a>
<FONT color="green">447</FONT>             * @see java.lang.Object#clone()<a name="line.447"></a>
<FONT color="green">448</FONT>             */<a name="line.448"></a>
<FONT color="green">449</FONT>            @SuppressWarnings("unchecked")<a name="line.449"></a>
<FONT color="green">450</FONT>            @Override<a name="line.450"></a>
<FONT color="green">451</FONT>            public DefaultIntIntMultiValueMap clone() {<a name="line.451"></a>
<FONT color="green">452</FONT>                    try {<a name="line.452"></a>
<FONT color="green">453</FONT>                            final Method meth = map.getClass().getMethod("clone");<a name="line.453"></a>
<FONT color="green">454</FONT>                            final IntMap&lt;IntCollection&gt; clonedMap = (IntMap&lt;IntCollection&gt;)meth.invoke(map);<a name="line.454"></a>
<FONT color="green">455</FONT>                            return new DefaultIntIntMultiValueMap(clonedMap);<a name="line.455"></a>
<FONT color="green">456</FONT>                    } <a name="line.456"></a>
<FONT color="green">457</FONT>                    catch (Exception e) {<a name="line.457"></a>
<FONT color="green">458</FONT>                            //map might not be cloneable, lets just create a new map now<a name="line.458"></a>
<FONT color="green">459</FONT>                            return new DefaultIntIntMultiValueMap(this);<a name="line.459"></a>
<FONT color="green">460</FONT>                    }<a name="line.460"></a>
<FONT color="green">461</FONT>            }<a name="line.461"></a>
<FONT color="green">462</FONT>            <a name="line.462"></a>
<FONT color="green">463</FONT>            /**<a name="line.463"></a>
<FONT color="green">464</FONT>             * Returns the value collection for the specified key. If no such<a name="line.464"></a>
<FONT color="green">465</FONT>             * collection exists, a new collection is <a name="line.465"></a>
<FONT color="green">466</FONT>             * {@link #createCollection(int) created} and added to the backing<a name="line.466"></a>
<FONT color="green">467</FONT>             * map.<a name="line.467"></a>
<FONT color="green">468</FONT>             * <a name="line.468"></a>
<FONT color="green">469</FONT>             * @param key           the key identifying the value collection<a name="line.469"></a>
<FONT color="green">470</FONT>             * @return      the value collection<a name="line.470"></a>
<FONT color="green">471</FONT>             */<a name="line.471"></a>
<FONT color="green">472</FONT>            protected IntCollection getOrCreateCollection(int key) {<a name="line.472"></a>
<FONT color="green">473</FONT>                    IntCollection coll = map.get(key);<a name="line.473"></a>
<FONT color="green">474</FONT>                    if (coll == null) {<a name="line.474"></a>
<FONT color="green">475</FONT>                            map.put(key, coll = createCollection(key));<a name="line.475"></a>
<FONT color="green">476</FONT>                    }<a name="line.476"></a>
<FONT color="green">477</FONT>                    return coll;<a name="line.477"></a>
<FONT color="green">478</FONT>            }<a name="line.478"></a>
<FONT color="green">479</FONT>            /**<a name="line.479"></a>
<FONT color="green">480</FONT>             * Returns a new int list instance. By default, an {@link ArrayList} of<a name="line.480"></a>
<FONT color="green">481</FONT>             * size one is created. The method shall never return null.<a name="line.481"></a>
<FONT color="green">482</FONT>             * <a name="line.482"></a>
<FONT color="green">483</FONT>             * @param key   the key for which a value collection is to be created<a name="line.483"></a>
<FONT color="green">484</FONT>             * @return              the new array list instance<a name="line.484"></a>
<FONT color="green">485</FONT>             */<a name="line.485"></a>
<FONT color="green">486</FONT>            protected IntCollection createCollection(int key) {<a name="line.486"></a>
<FONT color="green">487</FONT>                    return new DefaultIntList(1);<a name="line.487"></a>
<FONT color="green">488</FONT>            }<a name="line.488"></a>
<FONT color="green">489</FONT>            /**<a name="line.489"></a>
<FONT color="green">490</FONT>             * Returns a new map instance. By default, a {@link IntHashMap} is returned.<a name="line.490"></a>
<FONT color="green">491</FONT>             * The method shall never return null.<a name="line.491"></a>
<FONT color="green">492</FONT>             * <a name="line.492"></a>
<FONT color="green">493</FONT>             * @return              the new int hash map instance<a name="line.493"></a>
<FONT color="green">494</FONT>             */<a name="line.494"></a>
<FONT color="green">495</FONT>            protected IntMap&lt;IntCollection&gt; createMap() {<a name="line.495"></a>
<FONT color="green">496</FONT>                    return new IntHashMap&lt;IntCollection&gt;();<a name="line.496"></a>
<FONT color="green">497</FONT>            }<a name="line.497"></a>
<FONT color="green">498</FONT>    }<a name="line.498"></a>




























































</PRE>
</BODY>
</HTML>
